package com.zhongzheng.modules.activity.service;

import com.zhongzheng.modules.activity.bo.ActivityTaskUserAddBo;
import com.zhongzheng.modules.activity.domain.ActivityTaskUser;
import com.zhongzheng.modules.activity.vo.ActivityTaskUserVo;
import com.zhongzheng.modules.activity.bo.ActivityTaskUserQueryBo;
import com.zhongzheng.modules.activity.bo.ActivityTaskUserEditBo;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.Collection;
import java.util.List;

/**
 * 用户领取记录Service接口
 *
 * @author change
 * @date 2021-06-16
 */
public interface IActivityTaskUserService extends IService<ActivityTaskUser> {
	/**
	 * 查询单个
	 * @return
	 */
	ActivityTaskUserVo queryById(Long userId);

	/**
	 * 查询列表
	 */
	List<ActivityTaskUserVo> queryList(ActivityTaskUserQueryBo bo);

	/**
	 * 根据新增业务对象插入用户领取记录
	 * @param bo 用户领取记录新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(ActivityTaskUserAddBo bo);

	/**
	 * 根据编辑业务对象修改用户领取记录
	 * @param bo 用户领取记录编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(ActivityTaskUserEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);


	/**
	 * 签到
	 * @param bo 签到参数
	 * @return
	 */
    boolean userTask(ActivityTaskUserAddBo bo);


	/**
	 * 完善信息
	 * @param bo 参数
	 * @return
	 */
    boolean information(ActivityTaskUserAddBo bo) throws IllegalAccessException;


	/**
	 * 邀请好友
	 * @param bo 参数
	 * @return
	 */
	boolean invitation(ActivityTaskUserAddBo bo);


	/**
	 * 每日分享
	 * @param bo 参数
	 * @return
	 */
	boolean share(ActivityTaskUserAddBo bo);

	/**
	 * 学习时长
	 * @param bo 参数
	 * @return
	 */
	Integer learnTime(ActivityTaskUserAddBo bo);

	/**
	 * 模拟考试
	 * @param bo 参数
	 * @return
	 */
	boolean practiceTest(ActivityTaskUserAddBo bo);
}
